/*
    Bitio: Bit level input and output

    05/01/97 JSP Creation
*/

#ifndef BITIO_H
#define BITIO_H

#include <stdio.h>

class BitFile
{
public:
    BitFile (FILE *fp);
    void Write (unsigned long bits, unsigned width);
    char Read (unsigned width);
    void Flush ();

private:
    FILE *_fp;
    unsigned char _bit_reg;
    unsigned _bit_reg_width;
};

#endif